////////////////////////////////////////////////////////////////////////////////
///
///		Title		: Panel Component File
///
///		Copyright (c) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include	"Container.h"
#include "NPCommonUI.h"
#include "NControl.h"
#include "ScriptletContainerFactory.h"

class CNPanel;
/**
* @ingroup 	Base UI	
* @brief 	Panel UI Interface
* @date		10/25/2006
* @author	telltale
* @remark	
*/
interface NPCOMMONUI_API IPanelUI : public IComponentUI
{
public:
	virtual ~IPanelUI() {  }

	virtual void	DrawPanel(HDC hDC, CNPanel* pPanel) = 0;
	DECLARE_RTTI;
};
/**
* @ingroup 	Base UI		
* @brief 	Panel Component class
* @date		11/02/2006
* @author	telltale
* @remark	
*/
class NPCOMMONUI_API CNPanel : public CNControl
{
	DECLARE_RTTI
public:
	DECLARE_COMPONENT_CREATOR(CNPanel);
	CNPanel(void);
	virtual ~CNPanel(void);

//override
	LPCTSTR GetClassName() { return SCRIPTLET_PANEL_NODE; }
	/**
	* @brief 	set the ui object than renders this component
	* @param	pButtonUI	the ButtonUI ui object
	* @return	none
	*/
	void	SetUI(IComponentUI* pPanelUI);
	/**
	* @brief 	draw component
	* @param	hDC	HDC from parent window OnPaint function
	*/
	void OnDraw(HDC hDC);

	BOOL	HitTest(POINT pt) { return FALSE; }
};

//////////////////////////////////////////////////////////////////////////
// Deplicated Class since 070619
/**
* \group CommonUI
* \brief 
{kr} 
	4¸ ϴ г Ŭ. 
{/kr}
* \date 2006-11-03
* \author hhd2002
*/
class NPCOMMONUI_API CN4StatePanel : public CNPanel
{
	DECLARE_RTTI

// enum
public:
	enum ePanelState
	{
		E_PANEL_4STATE_NORMAL,
		E_PANEL_4STATE_OVER,
		E_PANEL_4STATE_DOWN,
		E_PANEL_4STATE_DIS,
	};


public:
	CN4StatePanel();
	virtual ~CN4StatePanel() {}

public:
	void SetState(ePanelState ePanelState);
	ePanelState GetState();

// override
public:
	/**
	 * @breif {kr} 콺 г  ̺Ʈ  г state ϰ ٽ ׷. {/kr}
	 */
	void OnMouseLeave();
	/**
	 * @breif {kr} 콺 moveؼ ʷ entered   г state ϰ ٽ ׷. {/kr}
	 */
	void OnMouseMove(UINT nFlags, CPoint point);

	BOOL	HitTest(POINT pt) { return CNControl::HitTest(pt); }

private:
	ePanelState m_state; ///< {kr} г state {/kr}
	BOOL m_bFirstIn;
};